function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import TeamixIcon from '@teamix/icon';
import { useAction } from '../../../../..';
import { usePrefixCls } from '@teamix/utils';
import React, { useState } from 'react';
import ProHoverTooltip from '../HoverTooltip';
import './index.scss';
var cls = usePrefixCls('teamix-pro-sidebar-icon-action');
var ProIconAction = function ProIconAction(props) {
  var _popupProps$wrapperCl;
  var trigger = props.trigger,
    action = props.action,
    visibleProp = props.visible,
    tooltip = props.tooltip,
    icon = props.icon;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  var popupProps = action === null || action === void 0 ? void 0 : action.popupProps;
  var wrapperClassName = (_popupProps$wrapperCl = popupProps === null || popupProps === void 0 ? void 0 : popupProps.wrapperClassName) !== null && _popupProps$wrapperCl !== void 0 ? _popupProps$wrapperCl : '';
  var _beforeOpen = popupProps === null || popupProps === void 0 ? void 0 : popupProps.beforeOpen;
  var _beforeClose = popupProps === null || popupProps === void 0 ? void 0 : popupProps.beforeClose;
  // 获取浮层类单独特殊配置
  var getPopProps = function getPopProps() {
    if (!action.type || action.type.includes('pop-confirm')) {
      return {
        popupProps: _objectSpread(_objectSpread({}, popupProps), {}, {
          wrapperClassName: "".concat(cls('overlay'), " ").concat(wrapperClassName, "}"),
          beforeOpen: function beforeOpen() {
            setVisible(true);
            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }
            _beforeOpen === null || _beforeOpen === void 0 ? void 0 : _beforeOpen.apply(void 0, args);
          },
          beforeClose: function beforeClose() {
            setVisible(false);
            for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = arguments[_key2];
            }
            _beforeClose === null || _beforeClose === void 0 ? void 0 : _beforeClose.apply(void 0, args);
          }
        })
      };
    }
    return {};
  };
  var processAction = useAction(_objectSpread(_objectSpread({
    align: 'bl',
    offset: [-10, 0],
    preventDefault: true,
    stopPropagation: true
  }, action), getPopProps()));
  var getTrigger = function getTrigger() {
    if (icon && typeof icon === 'string') {
      return /*#__PURE__*/React.createElement(TeamixIcon, _objectSpread({
        className: cls(),
        size: "small",
        type: icon
      }, processAction));
    }
    return /*#__PURE__*/React.createElement("span", _objectSpread({}, processAction), icon !== null && icon !== void 0 ? icon : trigger);
  };
  return /*#__PURE__*/React.createElement(ProHoverTooltip, {
    trigger: getTrigger(),
    visible: visible || visibleProp,
    tooltip: tooltip
  });
};
export default ProIconAction;